#include<iostream>
#include<assert.h>
#include<unistd.h>
#include "rect.h"
#include<stdio.h>
#include<stdlib.h>
using namespace std;

# define LEFT 1
# define RIGHT 2
# define UP 3
# define DOWN 4
# define SIZE 0.2
int object_count,add_score;//global variables.

SimpleWindow W1("Serpent MANIA", 16.0, 16.0, Position(0.0, 0.0));

struct snakedata 
{
 float length;
 double head_x; // Stores Head X Coordinate
 double head_y; // Stores Head Y Coordinate
 float head_dir; // Stores Head Direction
 float tail_x; // Stores Tail X Coordinat
 float tail_y; // Stores Tail Y Coordinat
 float tail_dir; // Stores Tail Direction
 float bend_x [1000]; //Stores X Bend Coordinate Declare it big enough to accomodate maximum bends
 float bend_y [1000];
 float bend_dir [1000]; // Stores Bend direction when tail reaches that X Coordinate
} Snake;





//Functions related to the problem begin from here.
//Screen Initialization.Drawing the initial snake.
int initscreen()
{
 
 for(int i=0;i<20;i++)
   {
    RectangleShape R(W1, 6.0 + i*SIZE , 8.0, Blue, SIZE, SIZE);
	R.Draw();
   }
 return 0;

}




//Done by Group B.
/*Creates objects for the snake to eat at random co-ordinates.Using rand() function.*/
void randomobject()
{
 
 int i,j;/*Variables which store the random values created between 0 and 15.These variables i and j are finally used as co-ordinates of the random object.*/
 srand(time(NULL));
 i=rand()%16;
 j=rand()%16;
 /*Checking if the random object is created on the snake or not.If it is so it assigns another random value to the respective variable i or j.*/
    if (Snake.head_dir == LEFT)
      {
       if(((i>Snake.head_x) || (i==Snake.head_x)) && ((i<Snake.tail_x) || (i==Snake.tail_x))&&(j==Snake.head_y))
          i=rand()%16;
      }
   
    else if (Snake.head_dir == RIGHT) 
       {
        if(((i<Snake.head_x) || (i==Snake.head_x)) && ((i>Snake.tail_x) || (i==Snake.tail_x))&&(j==Snake.head_y)) 
          i=rand()%16;
       }
    
    else if (Snake.head_dir == UP) 
       {
        if(((j<Snake.head_y) || (j==Snake.head_y)) && ((j>Snake.tail_y) || (j==Snake.tail_y))&&(i==Snake.head_x)) 
          j=rand()%16;
       }
    
    else if (Snake.head_dir == DOWN)
       {
        if(((j>Snake.head_y) || (j==Snake.head_y)) && ((j<Snake.tail_y) || (j==Snake.tail_y))&&(i==Snake.head_x))
          j=rand()%16;
       }
 if(object_count==6)//Displaying bonus object.
  {
   RectangleShape v(W1, i, j, Red, SIZE, SIZE);
   v.Draw();
   add_score=8;
   object_count=0;/*Addition of points to the score to be done in game physics function.add_score is the variable which keeps track of the points to be 
   added after each object is eaten.object_count keeps track of the number of simple objects eaten after each bonus object is eaten.*/
  }
 else//displays normal object.
  {
   RectangleShape w(W1, i, j,Green, SIZE, SIZE);
   w.Draw();
  }
}




//Done by Group B.
inline int collisioncheck()//Checking for collision with the walls(psuedo presently) present at x=0 and x=15,y=0 and y=15.
{
  if(Snake.head_dir == LEFT)
   {
    if (Snake.head_x == 0)
      {
        W1.RenderText(Position(8.0,4.0),Position(12.0,8.0),"Game over",Black,White);
        return 1;
      }
   }
  else if(Snake.head_dir == RIGHT)
   {
    if (Snake.head_x == 15.0)
      {
        W1.RenderText(Position(8.0,4.0),Position(12.0,8.0),"Game over",Black,White);
        return 1;
      }
   }
  else if(Snake.head_dir == UP)
   {
    if (Snake.head_y == 0)
      {
        W1.RenderText(Position(8.0,4.0),Position(12.0,8.0),"Game over",Black,White);
        return 1;
      }
   }
  else if(Snake.head_dir == DOWN)
   {
    if (Snake.head_y == 15.0)
      {
        W1.RenderText(Position(8.0,4.0),Position(12.0,8.0),"Game over",Black,White);
        return 1;
      }
   }
}   





int movesnake ()
 {
  //Move the Head
  if (Snake.head_dir == LEFT)
    {
      Snake.head_x =Snake.head_x - SIZE; 
    }
  if (Snake.head_dir == RIGHT) 
    {
      Snake.head_x =Snake.head_x + SIZE; 
    }
  if (Snake.head_dir == UP) 
    {
      Snake.head_y = Snake.head_y - SIZE;
    }
  if (Snake.head_dir == DOWN) 
    {
      Snake.head_y = Snake.head_y + SIZE ; 
    } 
  RectangleShape h(W1, Snake.head_x - SIZE , Snake.head_y , Blue, SIZE, SIZE);
  h.Draw();
 
  //Move the Tail
  RectangleShape j(W1, Snake.tail_x , Snake.tail_y ,White, SIZE, SIZE);
  j.Draw();
  if (Snake.tail_dir == LEFT)
    {
      Snake.tail_x =Snake.tail_x -SIZE; 
    }
  if (Snake.tail_dir == RIGHT) 
     {
       Snake.tail_x =Snake.tail_x + SIZE; 
     }
  if (Snake.tail_dir == UP) 
     {
       Snake.tail_y =Snake.tail_y - SIZE;
     }
  if (Snake.tail_dir == DOWN) 
     {
       Snake.tail_y =Snake.tail_y + SIZE; 
     } 
   return 1;          
}





void gameengine ()//Soul of our game.
{
  object_count=0,add_score=2;
  while(1)
    {
      movesnake ();
      collisioncheck();
      sleep(1);
     
    }
  
}





int ApiMain()
{
   
   // Open the windows
   W1.Open();
   assert(W1.GetStatus() == WindowOpen);

   Snake.length = 4.0;
   Snake.head_x = 10.0;
   Snake.head_y = 8.0;
   Snake.head_dir = RIGHT;
   Snake.tail_x = 6.0;
   Snake.tail_y = 8.0;
   Snake.tail_dir = RIGHT;
   for (int i = 0; i <1000;i++) // There is no bend initally
     {
      Snake.bend_x[i] = 0;
      Snake.bend_dir[i] = 0; 
     }
    initscreen();
    randomobject();
    gameengine();
return 1;

}      
